#include <atimer.h>
#include <allegro.h>

int atimer::global_counter;
int atimer::num_instances;

void atimer::counter_increment()
{
   global_counter++;
};
END_OF_FUNCTION( counter_increment );

atimer::atimer()
{
   if( num_instances == 0 )
   {
		// we need to install the timer handler.
		LOCK_VARIABLE( global_counter );
      LOCK_FUNCTION( counter_increment );
		install_timer();
		install_int( &counter_increment, 1 );
   };
   num_instances++;
};

atimer::~atimer()
{
	num_instances--;
	if( num_instances == 0 )
   {
   	// we need to uninstall the timer handler.
      remove_int( &counter_increment );
   };
};

void atimer::start()
{
	is_running = 1;
   int elapsed = counter_stop - counter_start;
   counter_start = global_counter - elapsed;
};

void atimer::stop()
{
	is_running = 0;
   counter_stop = global_counter;
};

void atimer::reset()
{
	is_running = 0;
	counter_start = global_counter;
   counter_stop = global_counter;
};
