//---------------------------------------------------------------------------
// atimer : intelligent timer class for use with allegro 2.1 for djgpp v2.
//
// by Calvin French 1997 (frenchc@cadvision.com)
//---------------------------------------------------------------------------

#ifndef __atimer_h
#define __atimer_h

class atimer
{
public:
	atimer();
	~atimer();
   void start();	//	starts or restarts the timer.
   void stop();	// pauses the timer.
   void reset();	// resets the timer to zero.
   int read() { return counter_stop - counter_start; };
   					// returns the elapsed time in milliseconds.
   bool status(); // returns 1 if the timer is running.
protected:
   int counter;
private:
	int counter_start;
   int counter_stop;
   bool is_running;
   static int num_instances;
	static volatile int global_counter;
   static void counter_increment();
};

#endif

