/* Copyright 1995-97 Jon Griffiths.  See the file "jlib.doc" for details. */

#include <stdio.h>
#include <stdlib.h>
#include <jlib.h>

/* demonstrates how to remap buffer colors */

int main(void)
{
 buffer_rec *buff;
 image *pcx_pic,*jlb_pic;
 UBYTE *remap;

 JLIB_DEBUG_OFF;

 screen_set_app_title("Demo16");

 if(!screen_set_video_mode())
    jlib_exit("Screen Setup failed.");

 screen_blank_pal();


 buff = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);

 /* load pcx image */
 pcx_pic=image_load_pcx("demo16.pcx");
 if(pcx_pic == NULL)
    jlib_exit("PCX load failed.");

 /* load jlb image */
 jlb_pic = image_load_jlb("demo16.jlb");
 if(jlb_pic == NULL)
    jlib_exit("JLB load failed.");

 /* put pcx_pic to screen with its own palette */
 screen_block_set_pal(IMG_PALETTE(pcx_pic));
 buff_blit_img_to(buff,0,0,pcx_pic,0,0,IMG_MAX_X(pcx_pic),IMG_MAX_Y(pcx_pic));
 screen_blit_fs_buffer(buff);

 fgetc(stdin);
  
 /* put jlib_pic to screen with the pcx's palette */
 buff_blit_img_to(buff,0,0,jlb_pic,0,0,IMG_MAX_X(jlb_pic),IMG_MAX_Y(jlb_pic));
 screen_blit_fs_buffer(buff);

 fgetc(stdin);

 /* remap the jlb images palette to the pcx's palette */
 remap = pal_create_remap_index(IMG_PALETTE(pcx_pic),IMG_PALETTE(jlb_pic));
 buff_remap_colors(buff,remap);
 screen_blit_fs_buffer(buff);

 fgetc(stdin);
  
 /* finally show jlib_pic with its own palette */
 screen_block_set_pal(IMG_PALETTE(jlb_pic));
 buff_blit_img_to(buff,0,0,jlb_pic,0,0,IMG_MAX_X(jlb_pic),IMG_MAX_Y(jlb_pic));
 screen_blit_fs_buffer(buff);

 fgetc(stdin);
 screen_restore_video_mode();
 return(0);
}