
#ifndef _FIXED2_H_
#define _FIXED2_H_

#include <limits.h>

typedef long fixed16;

static inline fixed16 fixmul16(fixed16 r1, fixed16 r2)
{
   fixed16 result;

   __asm__ ("imull %2\n\t"
            "shrd  $16, %%edx, %%eax\n\t"
	         :"=a" (result):"a" (r1), "d" (r2):"eax", "edx");

   return result;
}




static inline fixed16 fixdiv16(fixed16 dividend, fixed16 divisor)
{
   fixed16 result;

   // no checking for overflow is performed
   __asm__("movl %%edx, %%eax\n\t"
           "sar  $16, %%edx\n\t"
           "shl  $16, %%eax\n\t"
	        "idivl %%ecx, %%eax\n\t"
	        :"=a" (result):"d" (dividend), "c" (divisor):"eax", "ecx", "edx");

   return result;
}


#endif 
