#include <stdio.h>
#include <stdlib.h>
#include <dpmi.h>
#include <go32.h>
#include <pc.h>
#include <sys/movedata.h>

#define MAX_SCREENS 8

struct {
  int mode;
  char *data;
  short vgaseg;
  _go32_dpmi_seginfo int_vecp8,int_vecr8;
  _go32_dpmi_seginfo int_vecp9,int_vecr9;
  } s_info[MAX_SCREENS];


void Screen_Text()
{
__dpmi_regs r;

r.x.ss=r.x.sp=0;
/* read screen mode */
r.x.ax=0x0f00;
__dpmi_simulate_real_mode_interrupt(0x10,&r);
/*
if (r.h.al!=3)
  {
  r.x.ss=r.x.sp=0;
  r.x.ax=0x0003;
  __dpmi_simulate_real_mode_interrupt(0x10,&r);
  }*/
}


void Screen_Save(int nr,int vecsave)
{
__dpmi_regs r;

if (s_info[nr].data==NULL)
  {

r.x.ss=r.x.sp=0;
/* read screen mode */
r.x.ax=0x0f00;
__dpmi_simulate_real_mode_interrupt(0x10,&r);
s_info[nr].mode=r.h.al;

/* read video contents */
switch (s_info[nr].mode)
  {
  case 0x13: {
             s_info[nr].data=(char *)malloc(320*200);
             movedata((unsigned)_go32_conventional_mem_selector(),0xA0000,(unsigned)_go32_my_ds(),(unsigned)s_info[nr].data,320*200);
             break;
             }
  default:   {
             s_info[nr].data=(char *)malloc(80*50*2);
             movedata((unsigned)_go32_conventional_mem_selector(),0xB8000,(unsigned)_go32_my_ds(),(unsigned)s_info[nr].data,80*50*2);
             break;
             }
  }


/* read vga status */
r.x.ax=0x1c00;                                  /* check ramsize needed */
r.x.cx=0x0007;
__dpmi_simulate_real_mode_interrupt(0x10,&r);

r.x.ax=0x4800;                                  /* allocate it */
r.x.bx<<=2;
__dpmi_simulate_real_mode_interrupt(0x21,&r);
s_info[nr].vgaseg=r.x.ax;

r.x.ax=0x1c01;                                  /* save state */
r.x.bx=0;
r.x.cx=0x0007;
r.x.es=s_info[nr].vgaseg;
__dpmi_simulate_real_mode_interrupt(0x10,&r);


if (vecsave)
  {
  _go32_dpmi_get_protected_mode_interrupt_vector(8,&s_info[nr].int_vecp8);
  _go32_dpmi_get_protected_mode_interrupt_vector(9,&s_info[nr].int_vecp9);
  _go32_dpmi_get_real_mode_interrupt_vector(8,&s_info[nr].int_vecr8);
  _go32_dpmi_get_real_mode_interrupt_vector(9,&s_info[nr].int_vecr9);
  }

  }
}


void Screen_Restore(int nr,int vecsave)
{
__dpmi_regs r;

if (s_info[nr].data!=NULL)
  {

r.x.ss=r.x.sp=0;
/* read screen mode */
r.x.ax=0x0f00;
__dpmi_simulate_real_mode_interrupt(0x10,&r);
if (s_info[nr].mode!=r.h.al)
  {
  /* restore screen mode */
  r.x.ax=s_info[nr].mode|0x80;
  if ((s_info[nr].mode!=0x03)&&(s_info[nr].mode!=13)) r.x.ax|=0x80;
  __dpmi_simulate_real_mode_interrupt(0x10,&r);
  }

/* restore video contents */
switch (s_info[nr].mode)
  {
  case 0x13: {
             movedata((unsigned)_go32_my_ds(),(unsigned)s_info[nr].data,_go32_conventional_mem_selector(),0xA0000,320*200);
             free(s_info[nr].data);
             break;
             }
  default:   {
             movedata((unsigned)_go32_my_ds(),(unsigned)s_info[nr].data,_go32_conventional_mem_selector(),0xB8000,80*50*2);
             free(s_info[nr].data);
             break;
             }
  }

/* restore vga status */
r.x.ax=0x1c02;                                  /* restore state */
r.x.bx=0;
r.x.cx=0x0007;
r.x.es=s_info[nr].vgaseg;
__dpmi_simulate_real_mode_interrupt(0x10,&r);

r.x.ax=0x4900;                                  /* free it */
r.x.es=s_info[nr].vgaseg;
__dpmi_simulate_real_mode_interrupt(0x21,&r);
s_info[nr].data=NULL;

if (vecsave)
  {
  _go32_dpmi_set_protected_mode_interrupt_vector(8,&s_info[nr].int_vecp8);
  _go32_dpmi_set_protected_mode_interrupt_vector(9,&s_info[nr].int_vecp9);
  _go32_dpmi_set_real_mode_interrupt_vector(8,&s_info[nr].int_vecr8);
  _go32_dpmi_set_real_mode_interrupt_vector(9,&s_info[nr].int_vecr9);
  }

  }

}


