/* Copyright 1995-97 Jon Griffiths.  See the file "jlib.doc" for details. */

/*+------------------------------------------------------------------------+*/
/*| WATCOM/VESA Configuration Header.                                      |*/
/*+------------------------------------------------------------------------+*/ 

#ifndef __JCONFIG_H__
#define __JCONFIG_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Target System: Don't change this */
#define WATCOM

/* Target Graphics Mode: Only One of the three below should be uncommented */
#define WAT_320x200x256
/* #define WAT_640x480x256 */
/* #define WAT_800x600x256 */

/* Debugging Information: Comment this out to remove library validity checks*/
/* You should do this only when building your software for releases */
#define JDEBUG

/* Uncomment this line to make JLib check validity *very* carefully */
/* This should only be defined if JDEBUG is also defined */
/* #define JLIB_PARANOID */

/* Uncomment this line to build JLib with production code (reduced checking) */
/* This should only be defined if JDEBUG and JLIB_PARANOID are not defined */
/* #define JLIB_PRODUCTION */

/* Use default types: Don't change this */
#define JDEFAULT_TYPES

/* Use default debug code: Don't change this */
#define JDEFAULT_DEBUG

/* Let JLib handle simple signals: Don't change this */
#define JHANDLE_SIMPLE_SIGNALS

/* Use default palette code: Don't change these */
#define JDEFAULT_PALETTE
#define JDEFAULT_LOAD_PAL

/* Inline keyword: Don't change this */
#define JINLINE

/* Don't edit anything below this point */
#ifdef WAT_640x480x256
#define VESA_MODE 0x101
#endif

#ifdef WAT_800x600x256
#define VESA_MODE 0x103
#endif

#ifdef __cplusplus
}
#endif 

#endif
