/* Copyright 1995-97 Jon Griffiths.  See the file "jlib.doc" for details.   */

/*+------------------------------------------------------------------------+*/
/*| X_WINDOWS Configuration Header.                                        |*/
/*+------------------------------------------------------------------------+*/ 
#ifndef __JCONFIG_H__
#define __JCONFIG_H__

#ifdef __cplusplus
extern "C" {
#endif

/* Target System: Don't change this */
#define X_WINDOWS

/* Target Graphics Mode: Choose one of these */
#define X_320x200x256
/* #define X_640x480x256 */
/* #define X_800x600x256 */

/* Debugging Information: Comment this out to remove library validity checks*/
/* You should do this only when building your software for releases */
#define JDEBUG

/* Uncomment this line to make JLib check validity *very* carefully */
/* This should only be defined if JDEBUG is also defined */
/* #define JLIB_PARANOID */

/* Uncomment this line to build JLib with production code (reduced checking) */
/* This should only be defined if JDEBUG and JLIB_PARANOID are not defined */
/* #define JLIB_PRODUCTION */

/* Use default types: Don't change this */
#define JDEFAULT_TYPES

/* Use default debug code: Don't change this */
#define JDEFAULT_DEBUG

/* Let JLib handle certain signals: If your X platform supports the 
** sigaction() call for advanced signal handling, use this define (default): */
#define JHANDLE_SIGNALS

/* If you only have signal() then use this define: */ 
/* #define JHANDLE_SIMPLE_SIGNALS */

/* Use default palette code: Don't change these */
#define JDEFAULT_PALETTE
#define JDEFAULT_LOAD_PAL

/* Inline keyword: Change this if your compiler uses a different inline
** keyword: define it as blank if your compiler doesnt support this feature. */
#define JINLINE __inline

/* Don't edit anything below this point */

#ifdef __cplusplus
}
#endif 

#endif /* ifndef __JCONFIG_H__ */