/* Copyright 1996  Jonathan Griffiths. See "readme.jon" for detailed terms. */
#ifndef __LEVEL_H__              
#define __LEVEL_H__ 1 

#ifdef __cplusplus
extern "C" {
#endif

#include <jlib.h>
#include <stdlib.h>
#include <string.h>

/* level data type */
typedef struct{
     UBYTE magic;
     UBYTE width;
     UBYTE height;
     UBYTE block_width;
     UBYTE block_height;
     UBYTE num_blocks;
     sprite_system *blocks;
     UBYTE *map;
}level;

#define LEVEL_WIDTH(ptr)           ((ptr)->width)
#define LEVEL_HEIGHT(ptr)          ((ptr)->height)
#define LEVEL_MAP(ptr)             ((ptr)->map)
#define LEVEL_MAGIC                100   /* level file magic number */

level *level_init(int x,int y,sprite_system *sys);
level *level_load(char *filename,sprite_system *sys);
int    level_save(char *filename,level *newlevel);

level *level_free(level *level);
void   level_stencil(level *lev,buffer_rec *buff,int x,int y);
void   level_stamp(level *lev,buffer_rec *buff,int x,int y);

#ifdef __cplusplus
}
#endif 

#endif
