/* Copyright 1996  Jonathan Griffiths. See "readme.jon" for detailed terms. */
/* badly, hurredly written, like most utes */
#include <time.h>
#include <stdlib.h>
#include <jlib.h>
#include "level.h"

UBYTE global_col1 = 6;
UBYTE global_col2 = 15;

char popup_text[] ="Level Editor V1.0 - Jon Griffths\n\nKeys:\nCursor Keys = Move\nZ + Cursor Keys = Zoom\nQ/A = Change Block\nESC = Quit\n1/2 Change Colors\nDrag pane with mouse to move";

typedef struct {
      int x1,y1,w,h;
      int bx1,by1,bw,bh;
      buffer_rec *buff;
      buffer_rec *save;
      UBYTE *old_buff;
} pane;

void usage(void);
void init_pane(pane *p,int w,int h, char *text);
void draw_pane(pane *p,int x,int y, buffer_rec *buff);
void update_zoom(sprite_system *sys,sprite_system *save,int zoomx,int zoomy);


int main(int argc,char **argv)
{
 int level_width,level_height,temp,current_block=0;
 int tx,ty,toolx,tooly,buttons;
 int levx=0,levy=0,i,j,zoomx,zoomy;
 level *lev;
 UBYTE *pal=NULL;
 sprite_system *sys,*save;
 FILE *outfile;
 char *outname;
 pane tools;
 buffer_rec *offscreen;
 int redraw_flag=0;

 JLIB_DEBUG_OFF

 if((argc==5)||(argc==6)){
    level_width=atoi(argv[1]);
    level_height=atoi(argv[2]);

    if((level_width<=0)||(level_height<=0)||(level_width>255)||(level_height>255)){
       puts("ERROR:invalid X or Y size.");
       usage();
    }

    sys=sprite_init(1,255);

    if(sprite_load(argv[4],sys)!=SUCCESS){
       puts("ERROR: Couldn't load level block sprite file.");
       usage();
    }
    save=sprite_init(1,SPR_NUM_LOADED(sys));
    if(sprite_load(argv[4],save)!=SUCCESS){
       puts("ERROR: Couldn't load level block sprite file.");
       usage();
    }

    lev=level_init(level_width,level_height,sys);
    outfile=fopen(argv[3],"wb");
    if(outfile==NULL){
       puts("ERROR: Couldn't open level file for writing.");
       usage();
    }
    fclose(outfile);
    outname=argv[3];
    if(argc==6){
       pal=pal_load(argv[5]);
       if(pal==NULL){
          puts("ERROR: Couldn't open palette file for reading.");
          usage();
       }
    }      
 }
 else{
    if((argc==3)||(argc==4)){
       sys=sprite_init(1,255);
       if(sprite_load(argv[2],sys)!=SUCCESS){
          puts("ERROR: Couldn't load level block sprite file.");
          usage();
       }
       save=sprite_init(1,SPR_NUM_LOADED(sys));
       if(sprite_load(argv[2],save)!=SUCCESS){
          puts("ERROR: Couldn't load level block sprite file.");
          usage();
       }

       lev=level_load(argv[1],sys);

       if(lev==NULL){
          puts("ERROR: Couldn't open level file for reading.");
          usage();
       }
       outname=argv[1];
       if(argc==4){
          pal=pal_load(argv[3]);
          if(pal==NULL){
             puts("ERROR: Couldn't open palette file for reading.");
             usage();
          }
       }      

    }
    else{
       usage();
    }
 }

 screen_set_video_mode();

 if(pal!=NULL){
    screen_block_set_pal(pal);
 }

 if(!KEYBOARD_AVAILABLE){
    jlib_exit("No Keyboard Support.");
 } 
 if(!MOUSE_AVAILABLE){
    jlib_exit("No Mouse Support.");
 } 

 /* init stuff*/
 temp=CHAR_WIDTH('a')*8;
 if(temp<SPR_MAX_X){
    temp=SPR_MAX_X;
 }

 init_pane(&tools, temp,SPR_MAX_Y+2," Block ");
 buff_fill(tools.buff,6);
 buff_stamp_sprite(lev->blocks,current_block,tools.buff,1,1);
 zoomx=lev->blocks->sprite_data[0]->width;
 zoomy=lev->blocks->sprite_data[0]->height;

 offscreen=buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);

 screen_blit_fs_buffer(offscreen);

 kb_init();
 mouse_present();
 mouse_show_pointer();

 while(!kb_keydown(KEY_ESC)){
   if(kb_keydown(KEY_Q)){
      if(current_block>0){
         current_block--;
      }
      else{
         current_block=(lev->num_blocks-1);
      }
      redraw_flag=1;
   }
   if(kb_keydown(KEY_A)){
      if(current_block==(lev->num_blocks-1)){
         current_block=0;
      }
      else{
         current_block++;
      }
      redraw_flag=1;
   }
   mouse_get_status(&tx,&ty,&buttons);

   if(BUTTON_DOWN(buttons)&&
     (tx<=(toolx+tools.w))&&(ty<=(tooly+tools.h))&&(tx>=toolx)&&(ty>=tooly)){
      while(BUTTON_DOWN(buttons)){
            mouse_get_status(&tx,&ty,&buttons);
            draw_pane(&tools,tx,ty,offscreen);
            mouse_hide_pointer();
            screen_blit_buff_to(tx,ty,offscreen,tx,ty,tx+tools.w,ty+tools.h);
            mouse_show_pointer();
      }
      toolx=tx;
      tooly=ty;
      redraw_flag=1;
   }
   else{
      if(BUTTON_DOWN(buttons)){
        /* place a block */
        lev->map[(levy+(ty/lev->blocks->sprite_data[0]->height))*lev->width+(levx+(tx/lev->blocks->sprite_data[0]->width))]=current_block;
      }
      redraw_flag=1;
   }

   buff_clear(offscreen);

   if(redraw_flag){
     for(j=0;j<SCREEN_HEIGHT/lev->blocks->sprite_data[0]->height;j++){
        for(i=0;i<SCREEN_WIDTH/lev->blocks->sprite_data[0]->width;i++){
            if(((levy+j)<lev->height)&&((levx+i)<lev->width)){
               if(lev->map[(levy+j)*lev->width+(levx+i)]){
                 buff_stamp_sprite(lev->blocks,lev->map[(levy+j)*lev->width+(levx+i)],offscreen,
                   i*lev->blocks->sprite_data[0]->width,j*lev->blocks->sprite_data[0]->height);
               }
            }
        }
     }
     /* draw our 'toolbar' */
     buff_fill(tools.buff,global_col1);
     buff_stamp_sprite(save,current_block,tools.buff,1,1);
     draw_pane(&tools,toolx,tooly,offscreen);
   
     mouse_hide_pointer();
     screen_blit_fs_buffer(offscreen);
     mouse_show_pointer();
     redraw_flag=0;
   }

   if(kb_keydown(KEY_F1)){
      popup_info(popup_text,global_col1,global_col2);
      redraw_flag=1;
   }

   if(kb_keydown(KEY_1)){
      global_col1++;
      redraw_flag=1;
   }
   if(kb_keydown(KEY_2)){
      global_col2++;
      redraw_flag=1;
   }

   if(kb_keydown(KEY_Z)){
      if(kb_keydown(KEY_DOWN)){
         if(zoomy<SPR_MAX_Y-2){
            zoomy++;
            update_zoom(sys,save,zoomx,zoomy);
            redraw_flag=1;
         }
      }
      if(kb_keydown(KEY_UP)){
         if(zoomy>1){
            levx=levy=0;
            zoomy--;
            update_zoom(sys,save,zoomx,zoomy);
            redraw_flag=1;
         }
      }
      if(kb_keydown(KEY_RIGHT)){
         if(zoomx<SPR_MAX_X-2){
            zoomx++;
            update_zoom(sys,save,zoomx,zoomy);
            redraw_flag=1;
         }
      }
      if(kb_keydown(KEY_LEFT)){
         if(zoomx>1){
            levx=levy=0;
            zoomx--;
            update_zoom(sys,save,zoomx,zoomy);
            redraw_flag=1;
         }
      }
      lev->block_width=sys->sprite_data[0]->width;
      lev->block_height=sys->sprite_data[0]->height;
   }
   else{
      if(kb_keydown(KEY_UP)){
         if(levy!=0){
            levy--;
            redraw_flag=1;
         }
      }
      if(kb_keydown(KEY_DOWN)){
         if(levy<(lev->height-(SCREEN_HEIGHT/lev->blocks->sprite_data[0]->height))){
            levy++;
            redraw_flag=1;
         }    
      }

      if(kb_keydown(KEY_LEFT)){
         if(levx!=0){
            levx--;
            redraw_flag=1;
         }
      }
      if(kb_keydown(KEY_RIGHT)){
         if(levx<(lev->width-(SCREEN_WIDTH/lev->blocks->sprite_data[0]->width))){
            levx++;
            redraw_flag=1;
         }
      }
   }

 }


 level_save(outname,lev);

 mouse_closedown();
 kb_closedown();

 screen_restore_video_mode();
 return(1);
}


/* display usage information */
void usage(void)
{
 puts("lev_edit.exe: Create or edit level files");
 puts("Usage: lev_edit.exe [<w> <h>] <level_file> <sprite_file>");
 puts("Where: [] indicates optional parameters.");
 puts("      1. If <w> and <h> are given they are used as the size of a new level");
 puts("          which will be created in file <level_file>.");
 puts("      2. If w and h are not given then the file <level_file> is loaded");
 puts("          to be edited.");
 puts("  In both cases <sprite_file> is the JLib sprite file containing the");
 puts("  block graphics for the level.\n");
 exit(0);
}

void init_pane(pane *p,int w,int h, char *text)
{
 /* setup size info */
 p->x1=p->y1=0;
 p->bw=p->w=w;
 p->h=h;
 p->bx1=p->by1=2;
 p->bh=CHAR_HEIGHT('a')+3;

 /* save buffer details */
 p->buff=buff_init(w,h+p->bh);
 p->save=buff_init(w,h+p->bh);
 p->old_buff=B_BUFF_PTR(p->buff);

 /* draw header */
 buff_draw_rect(p->buff,0,0,p->w-1,p->bh-1,global_col1);
 buff_draw_string(p->buff,text,1,2,global_col2);
 buff_draw_h_line(p->buff,0,p->bh-1,p->bw-1,global_col2);

 /* change buffer details: skip header */
 p->buff->buffer+=(p->w * p->bh);
 p->buff->height-= p->bh;

}

void draw_pane(pane *p,int x,int y, buffer_rec *buff)
{
 buffer_rec fake;

 fake.width=p->w;
 fake.height=p->h;
 fake.buffer=p->old_buff;

 buff_blit_buff_to(buff,x,y,&fake,0,0,p->w,p->h);
}


/* rebuilds the sprite system dynamically as a different size */
void update_zoom(sprite_system *sys,sprite_system *save,int zoomx,int zoomy)
{
 buffer_rec *one,*two;
 int i;

 one=buff_init(SPR_MAX_X,SPR_MAX_Y);
 two=buff_init(SPR_MAX_X,SPR_MAX_Y);

 for(i=0;i<SPR_NUM_LOADED(save);i++){
     buff_clear(one);
     buff_clear(two);
     buff_stamp_sprite(save,i,one,0,0);
     buff_scale_buff_to(two,0,0,zoomx,zoomy,one,0,0,save->sprite_data[i]->width,save->sprite_data[i]->height);
     sprite_build_from_buff(sys,i,two,0,0,zoomx,zoomy);
 }

 buff_free(one);
 buff_free(two);
}
