/* Copyright 1996  Jonathan Griffiths. See "readme.jon" for detailed terms. */
#include <time.h>
#include <stdlib.h>
#include <jlib.h>
#include "level.h"

int OFF= 2;
/* use 'Q' and 'A' keys to increase/decrease offset while scrolling */

int main(int argc,char **argv)
{
 int i,xpos=100,ypos=100,xp2=100,yp2=100;
 level *lev;
 sprite_system *sys;
 buffer_rec *offscreen,*img;
 image *jlb_pic;
 char foo[30];
 UBYTE *pal;

 JLIB_DEBUG_OFF

 if((argc!=4)&&(argc!=5)){
    puts("lev_view.exe : view level files.");
    puts("Usage: lev_view <level> <sprite> <palette> [<background>]");
    puts("<background> is an optional .jlb file to show as a background.");
    exit(0);
 }

 screen_set_video_mode();
  
 if(!KEYBOARD_AVAILABLE){
    jlib_exit("No Keyboard Support.");
 } 

 /* init stuff*/
 offscreen = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);
 sys=sprite_init(18,90);
 if(sys==NULL){
    jlib_exit("Sprite init failed");
 }
 if(sprite_load(argv[2],sys)!=SUCCESS){
    jlib_exit("Sprite load failed");
 }

 if(argc==5){
    jlb_pic = image_load_jlb(argv[4]);
    if(jlb_pic == NULL){
       jlib_exit("JLB load failed.");
    }
 }

 pal=pal_load(argv[3]);
 if(pal==NULL){
    jlib_exit("Palette load failed.");
 }

 kb_init();
 lev=level_load(argv[1],sys);

 if(lev==NULL){
    jlib_exit("Couldn't open level file for reading.");
 }

 if(argc==5){
    if((SCREEN_WIDTH!=IMG_WIDTH(jlb_pic))||(SCREEN_HEIGHT!=IMG_HEIGHT(jlb_pic))){
      /* have to scale background image */
      img=buff_init(IMG_WIDTH(jlb_pic),IMG_HEIGHT(jlb_pic));
      buff_blit_img_to(img,0,0,jlb_pic,0,0,IMG_MAX_X(jlb_pic),IMG_MAX_Y(jlb_pic));
    } 
 }


 screen_block_set_pal(pal);

 for(i=0;i<99999999;i++){
   if(argc==5){
     if((SCREEN_WIDTH!=IMG_WIDTH(jlb_pic))||(SCREEN_HEIGHT!=IMG_HEIGHT(jlb_pic))){
         buff_scale_full_buff_to(offscreen,0,0,B_MAX_X(offscreen),B_MAX_Y(offscreen),img);
      }
      else{
         buff_blit_img_to(offscreen,0,0,jlb_pic,0,0,IMG_MAX_X(jlb_pic),IMG_MAX_Y(jlb_pic));
      }

   }
   else{
      buff_clear(offscreen);
   }

   level_stencil(lev,offscreen,xpos,ypos);

   /* uncomment this line for a 2 layer parallax effect */
   /* level_stencil(lev,offscreen,xp2,yp2); */

   /* draw our position into the buffer */
   sprintf(foo,"%3d %3d",xpos,ypos);
   buff_draw_string(offscreen,foo,10,10,15);
   screen_blit_fs_buffer(offscreen);

   if(kb_keydown(KEY_Q)){
      OFF++;
   }
   if(kb_keydown(KEY_A)){
      if(OFF){
         OFF--;
      }
   }

   if(kb_keydown(KEY_UP)){
      ypos-=OFF;
      yp2-=OFF*2;
   }
   if(kb_keydown(KEY_DOWN)){
      ypos+=OFF;
      yp2+=OFF*2;
   }

   if(kb_keydown(KEY_LEFT)){
      xpos-=OFF;
      xp2-=OFF*2;
   }
   if(kb_keydown(KEY_RIGHT)){
      xpos+=OFF;
      xp2+=OFF*2;
   }
   if(kb_keydown(KEY_ESC)){
      break;
   }

 };

 kb_closedown();

 screen_restore_video_mode();
 return(1);
}
