/* Copyright 1996  Jonathan Griffiths. See "readme.jon" for detailed terms. */
#include <time.h>
#include <stdlib.h>
#include <jlib.h>
#include "level.h"

#define OFF 1
#define RANDOM(u) ( rand() % ( ((u) + 1)  ) )


void level_make(char *filename);

int main(int argc,char **argv)
{
 int i,xpos=100,ypos=100,xp2=100,yp2=100;
 level *lev;
 sprite_system *sys;
 buffer_rec *offscreen;
 image *jlb_pic;
 char foo[30];

 JLIB_DEBUG_OFF
 screen_set_video_mode();
  
 if(!KEYBOARD_AVAILABLE){
    jlib_exit("No Keyboard Support.");
 } 

 /* init stuff*/
 offscreen = buff_init(SCREEN_WIDTH,SCREEN_HEIGHT);
 sys=sprite_init(18,90);
 sprite_load("in.spr",sys);
 jlb_pic = image_load_jlb("level.jlb");
 if(jlb_pic == NULL){
    jlib_exit("JLB load failed.");
 }

 srand(time(NULL));

 kb_init();
 level_make("new");

 lev=level_load("new",sys);

 for(i=0;i<99999999;i++){
   buff_blit_img_to(offscreen,0,0,jlb_pic,0,0,IMG_MAX_X(jlb_pic),IMG_MAX_Y(jlb_pic));
   level_stamp(lev,offscreen,xpos,ypos);
   level_stencil(lev,offscreen,xp2,yp2); 

   sprintf(foo,"%3d %3d",xpos,ypos);
   buff_draw_string(offscreen,foo,10,10,15);
   screen_blit_fs_buffer(offscreen);

   if(kb_keydown(KEY_UP)){
      ypos-=OFF;
      yp2-=OFF*2;
   }
   if(kb_keydown(KEY_DOWN)){
      ypos+=OFF;
      yp2+=OFF*2;
   }

   if(kb_keydown(KEY_LEFT)){
      xpos-=OFF;
      xp2-=OFF*2;
   }
   if(kb_keydown(KEY_RIGHT)){
      xpos+=OFF;
      xp2+=OFF*2;
   }
   if(kb_keydown(KEY_Q)||kb_keydown(KEY_ESC)){
      break;
   }

 };

 kb_closedown();

 screen_restore_video_mode();
 return(1);
}

/* write a random level */
void level_make(char *filename)
{
 int i,j;
 FILE *fp;

 /* open level file */
 if((fp=fopen(filename,"wb"))== NULL){
    return;
 }

 /* put level details */
 fputc(LEVEL_MAGIC,fp);

 fputc(64,fp);
 fputc(64,fp);

 srand(time(NULL));

 for(i=0;i<64;i++){
    fputc(9,fp);
 }
 for(i=0;i<62;i++){
     fputc(9,fp);
     for(j=0;j<62;j++){
        if(RANDOM(15)<5){
           fputc(RANDOM(15),fp);
        }
        else{
           fputc(0,fp);
        }
     }
     fputc(9,fp);

 }
 for(i=0;i<64;i++){
    fputc(9,fp);
 }


 fclose(fp);
}



