  /* /////////////////////////////////////////////////////////////// */
 /* /// BMP_CONV.H                                              /// */
/* /////////////////////////////////////////////////////////////// */
	/* --- Elmar Vogt - V1.0 - 1.96 - DJGPP C 2.003 --------- */

/*	this file contains the user interface for a number of conversion
	routines between the popular windows 3.x-bmp-image file format,
	and the pbm format as used by Paul Fenwick's XLib graphics
	library. */

/* *************************************************************** */
/* *** IMPORTANT NOTE :	this software comes without warranty 	*** */
/* *** of any kind; it is public domain and not for resale.		*** */
/* *** copyright exists in portions of this software.				*** */
/* *** please, refer to the file BMP_CONV.DOC for details.		*** */
/* *************************************************************** */

/* note: we used the convention throughout to make the target the
	first function parameter, while source follows. */

/* === include-files =============================================== */
#ifndef	_BMP_INCLUDE_
#define	_BMP_INCLUDE_

/*	IO-routines: */
#include <stdlib.h>
#include <stdio.h>

/* stuff for xlib: */
#include <xlib.h>
	/* currently this is from the file _XLIBDJ25.ZIP_, which is
		version 2.5 for use with djgpp v2.0 */
#include <defines.h>
#include <archive.h>
#include <colors.h>

/* === definitions ================================================= */
#define	MAX_X			ScrnPhysicalPixelWidth
#define	MAX_Y			ScrnPhysicalHeight

#define	OVERWRITE	TRUE
#define	MATCH			FALSE

typedef enum{NONE, SHRINK, MAGNIFY, ANTIALIAS} CORRECT_DISTORTION;

/* === operations on bmp-files====================================== */
int		load_bmp(BYTE **, BYTE *, char *, BOOLEAN, CORRECT_DISTORTION);
int		save_bmp_box(char *, int , int, int , int, BYTE*);

/* === palette adaption functions ================================== */
void		palette_make_pbm(BYTE *, BYTE *);
void		palette_make_bmp(BYTE *, BYTE *);
void		make_best_palette_match(BYTE*, BYTE *, BYTE *);
int		best_color_match(BYTE *, int, int, int);

/* === reading and writing values in/from intel format ============= */
long		read_long_intel(BYTE *);
int		read_int_intel(BYTE *);
void		write_long_intel(BYTE *, unsigned long);
void		write_int_intel(BYTE *, unsigned int);

/* === miscellaneous =============================================== */
/* setting up an array of bytes */
BYTE*		byte_array(unsigned long);
/* aligning a number, so it's value will be the next larger multiple of
	four: */
long		align_long(unsigned long);

#endif							/* _BMP_INCLUDE_ */

