
  /* /////////////////////////////////////////////////////////////// */
 /* /// BMP_DEMO.C                                              /// */
/* /////////////////////////////////////////////////////////////// */
	/* --- Elmar Vogt - V1.0 - 1.96 - DJGPP C 2.003 --------- */

/* this program contains a short demo to demonstrate the capabilities of
	the BMP_CONV-routines. */

/* ================================================================= */
#include "bmp_conv.h"
#include <pc.h>

/* ================================================================= */
void welcome();
void copyright();
void goodbye();
void cr();
void x_out(char *);
void x_clear();
void when_ready();

/* ================================================================= */
BYTE *palette, *font;
char key;
BYTE resolution;
int text_color= 133;
int x_left=1, x_middle= 160, y_start=118;
int i;

BYTE *jennifer, *jennifer2, *jennifer3, *jennifer4, *jennifer5,
	*heather;

/* ================================================================= */
void main(){

	welcome();
	copyright();

	/* startup question */
	resolution= 1;

	printf("Is your monitor able to handle 360 pixels-resolutions?\n");
	key= getkey();
	while(key!='y' && key!='n'){
		printf("Hit 'y' for 'yes', 'n' for 'no'!\n");
		key=getkey();
	}
	resolution= (key=='y') ? TRUE : FALSE;

	printf("Starting graphics demonstration...\n");

	/* load a standard palette & font */
	read_binary("standard.pal", &palette);
	read_binary("timpani.fnt", &font);
		/* adapt paths, if necessary! */

	if(resolution)
		x_set_mode(X_360X480);
	else
		x_set_mode(X_320X480);
		/* use the very highest resolutions obtainable! */

	x_set_palette(palette);

	x_out(NULL);
	x_out("HELLO- LET'S START WITH A SIMPLE BMP_PICTURE FROM DISK!");
	x_out("THIS IS ACTRESS JENNIFER CONELLY IN A 256-COLOR BITMAP:");

	load_bmp(&jennifer, palette, "jennifer.bmp", MATCH, NONE);
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer);
	x_out("OH DEAR- SHE DOESN'T LOOK TOO WELL!");
	x_out("THE REASON IS, THAT WE MATCHED THE COLORS OF HER IMAGE");
	x_out("TO THAT OF THE EXISTING PALETTE.");
	x_out("WE CAN CHANGE THIS BY OVERWRITING THE EXISTING PALETTE WITH");
	x_out("THE ONE FROM HER IMAGE. (THUS SCRAMBLING ALL OLD COLORS...)");
	when_ready();

	load_bmp(&jennifer, palette, "jennifer.bmp", OVERWRITE, NONE);
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer);
	palette[0]= (palette[1]= (palette[2]= 0));
		/* black background */
	x_set_palette(palette);
	x_out("MUCH BETTER, ISN'T IT?");
	when_ready();

	x_out(NULL);
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer);
	x_out("BUT SHE LOOKS PRETTY DISTORTED.");
	x_out("THIS IS DUE TO THE FACT, THAT IN OUR VIDEO MODE EVERY LINE");
	x_out("IS ONLY HALF AS HIGH AS IN 'STANDARD' RESOLUTIONS.");
	x_out("WHAT IS TO DO?");
	x_out("WE CAN DROP EVERY SECOND COLUMN FOR A NARROWER IMAGE.");
	load_bmp(&jennifer2, palette, "jennifer.bmp", OVERWRITE, SHRINK);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer2);
	when_ready();
	x_out("OR WE COULD PAINT EVERY ROW TWICE:");
	load_bmp(&jennifer3, palette, "jennifer.bmp", OVERWRITE, MAGNIFY);
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer3);
	when_ready();

	x_out(NULL);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer2);
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer3);
	x_out("BUT THIS DOESN'T LOOK TOO GOOD.");
	x_out("PROPORTIONS ARE CORRECT, BUT ONE CAN CLEARLY NOTICE THE");
	x_out("LARGER EFFECTIVE PIXELS.");
	x_out("OUR REMEDY? TO INTERPOLATE EVERY SECOND ROW BETWEEN THE");
	x_out("ONE'S PRECEEDING AND SUCCEEDING IT, RESP.");
	x_out("AS YOU WILL SEE, THIS LEADS TO A MUCH SMOOTHER IMAGE.");
	x_out("(PLEASE WAIT A SECOND.)");
	load_bmp(&jennifer4, palette, "jennifer.bmp", OVERWRITE, ANTIALIAS);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer4);
	when_ready();

	x_out(NULL);
	x_out("WE CAN ALSO DEAL WITH TRUE COLOR IMAGES.");
	x_out("SINCE WE ARE LIVING IN A 256-COLOR MODE, WE CANNOT HELP");
	x_out("BUT MAKE AN APPROXIMATION, MAPPING THE 2^24 SOURCE COLORS");
	x_out("TO THE 256 TARGET PALETTE COLORS AVAILABLE.");
	x_out("THIS CAN WORK FAIRLY WELL. LEFT IS THE OLD IMAGE WITH 256");
	x_out("COLORS, RIGHT A MAPPED TRUE COLOR IMAGE WILL APPEAR SOON:");
	x_out("(PLEASE WAIT A SECOND.)");
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer4);
	load_bmp(&jennifer5, palette, "jennif2.bmp", MATCH, ANTIALIAS);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer5);

	when_ready();
	x_out(NULL);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer5);
	x_out("BUT IT CAN ALSO YIELD POOR RESULTS.");
	x_out("IN A FEW SECONDS, ON THE LEFT HALF OF THE SCREEN HEATHER");
	x_out("LOCKLEAR WILL APPEAR.");
	x_out("");
	x_out("SUCCESS HIGHLY DEPENDS ON THE SIMILARITY OF THE CHOSEN");
	x_out("SCENERY!");
	x_out("(PLEASE WAIT A SECOND.)");
	x_put_PBM(x_left, y_start, Page0_Offs, jennifer4);
	x_put_PBM(x_middle, y_start, Page0_Offs, jennifer5);
	load_bmp(&heather, palette, "heather.bmp", MATCH, ANTIALIAS);
	x_put_PBM(x_left, y_start, Page0_Offs, heather);
	when_ready();

	x_set_text_mode();

	free(jennifer);
	free(jennifer2);
	free(jennifer3);
	free(jennifer4);
	free(jennifer5);
	free(heather);

	goodbye();
}

/* ================================================================= */
void welcome(){
	cr(); cr();
	printf("Welcome to the BMP_CONV set of conversion routines!\n");
	cr();
	printf("These provide you with a means of converting images in\n");
	printf("the popular BMP-format (as used by Microsoft's Paint-\n");
	printf("brush) to PBMs as used by Paul Fenwick's XLIB-emulation\n");
	printf("back and forth.\n");
	printf("For more documentation, see the file 'BMP_CONV.DOC'!\n");
}

void copyright(){
	cr();
	printf("PBM_CONV is (c)opyright 1996 by Elmar Vogt, Nuernberg.\n");
	printf("It is Public Domain Mail Ware.\n");
	printf("Other copyrights infringed by the use of this\n");
	printf("application are that of DJ DeLories DJGPP-project, the\n");
	printf("GNU Software Foundation's GCC compiler and last, but not\n");
	printf("least that of Paul Fenwick, who wrote the XLIB.\n");
	printf("Please, refer to the file BMP_CONV.DOC for details!\n");
	cr();
}

void goodbye(){
	cr();
	printf("That was all I could show you.\n");
	printf("Thanks for your interest, and have fun with my utility!\n");
	cr();
	printf("Elmar Vogt \t\t\t elmar.vogt@rzmail.uni-erlangen.de\n");
	printf("\t\t\t\t http://www.rrze.uni-erlangen.de\n");
}

void cr(){
	printf("\n");
}

void x_out(char *string){
	static out=0;

	if(string==NULL){
		out=0;
		x_clear();
	}
	else{
		x_printf(1, out+=12, Page0_Offs, text_color, font,	string);
	}
}

void x_clear(){
	x_rect_fill(0, 0, MAX_X, MAX_Y, Page0_Offs, 0);
}

void when_ready(){
	x_printf(1, 465, Page0_Offs, 15, font,
		"HIT A KEY WHEN READY!");
	fflush(stdin);
	getkey();
}
