#include "includes.h"

void startup_video(int card,int scr_width,int scr_height)
{
	int result;	
	result=set_gfx_mode(card,scr_width,scr_height,0,0);
	if(result!=0){
		premature_quit("set video mode");
	}
	set_pallete(black_pallete);
}

void shutdown_video(void)
{
	text_mode(0); //restores the video mode at end of game/crash
}

void premature_quit(char *where_crash) //if something unexpected happens, this will report it!
{
	char *video_problem="set video mode";
	
	shutdown_video();
	shutdown_sound();
	allegro_exit();
	fprintf(stderr,"\nUh oh!! :-(\n\nUnexpected exit.  Reason: %s\n",where_crash);
	if(where_crash==video_problem){
		printf("%s requires at least a VGA card (get with it!) ;-)\n",XSIV_TITLE);
	}
	fflush(stdout);
	exit_game(); //safe to do because everything is released
}

void startup_game_info(void)
{
	clrscr();
	printf("%s\n\n",FAKE_DOS4GW);
	printf("%s - %s\n",XSIV_TITLE,XSIV_VERSION);
	printf("by %s\n\n",XSIV_NAME);
	puts(allegro_id);
	puts(mikbanner);
	fflush(stdout);
}

void startup_sound(void)
{
	md_mixfreq=44100;
	md_dmabufsize=20000;
	md_mode=DMODE_16BITS|DMODE_STEREO;
	md_device=0; /*autodetect the sound card*/
	ML_RegisterLoader(&load_xm);
	MD_RegisterDriver(&drv_nos);
	MD_RegisterDriver(&drv_ss);
	MD_RegisterDriver(&drv_sb);
	MD_RegisterDriver(&drv_gus);
	MD_RegisterPlayer(tickhandler);
	//----------------------------------------
	if(!MD_Init()){
		fprintf(stderr,"Driver error: %s.\n",myerr);
		premature_quit("Can't load soundcard.");
	}
	printf("Sound autodetect: %s\n",md_driver->Name);
	fflush(stdout);
}

void shutdown_sound(void)
{
	MD_Exit();
}

void tickhandler(void) //this function is used to handle the music and snd
{
	MP_HandleTick();
	MD_SetBPM(mp_bpm);
}

void exit_game(void)
{
	shutdown_video();
	shutdown_sound();
	allegro_exit();
	exit(0);
}

void blit_dblbuffer(void)
{
	vsync();
	blit(dblbuffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
}