  /* /////////////////////////////////////////////////////////////// */
 /* ///   led.cc                                                /// */
/* /////////////////////////////////////////////////////////////// */
	/* --- Elmar Vogt - V1.0 - 2.96 - DJGPP C++ 2.003 ------- */

/* ================================================================= */

/* === include-files =============================================== */
#include "led.h"

/* === data initialization ========================================= */
// nicht ganz der gipfel der eleganz... nunja.
static const struct{
	BYTE ascii;
	BYTE pattern[7];
} led0[]={
	{' ', {0, 0, 0, 0, 0, 0, 0}},	{'0', {1, 1, 1, 0, 1, 1, 1}},
	{'1', {0, 0, 1, 0, 0, 1, 0}},	{'2', {1, 0, 1, 1, 1, 0, 1}},
	{'3', {1, 0, 1, 1, 0, 1, 1}},	{'4', {0, 1, 1, 1, 0, 1, 0}},
	{'5', {1, 1, 0, 1, 0, 1, 1}},	{'6', {1, 1, 0, 1, 1, 1, 1}},
	{'7', {1, 0, 1, 0, 0, 1, 0}},	{'8', {1, 1, 1, 1, 1, 1, 1}},
	{'9', {1, 1, 1, 1, 0, 1, 1}},	{'a', {1, 0, 1, 1, 1, 1, 1}},
	{'b', {0, 1, 0, 1, 1, 1, 1}},	{'c', {0, 0, 0, 1, 1, 0, 1}},
	{'d', {0, 0, 1, 1, 1, 1, 1}},	{'e', {1, 1, 1, 1, 1, 0, 1}},
	{'f', {1, 1, 0, 1, 1, 0, 0}},	{'g', {1, 1, 1, 1, 0, 1, 1}},
	{'h', {0, 1, 0, 1, 1, 1, 0}},	{'i', {0, 0, 0, 0, 1, 0, 0}},
	{'j', {0, 0, 1, 0, 0, 1, 1}},	{'k', {0, 1, 0, 1, 1, 1, 0}},
	{'l', {0, 1, 0, 0, 1, 0, 1}},	{'m', {1, 1, 1, 0, 1, 1, 0}},
	{'n', {0, 0, 0, 1, 1, 1, 0}},	{'o', {0, 0, 0, 1, 1, 1, 1}},
	{'p', {1, 1, 1, 1, 1, 0, 0}},	{'q', {1, 1, 1, 1, 0, 1, 0}},
	{'r', {0, 0, 0, 1, 1, 0, 0}},	{'s', {1, 1, 0, 1, 0, 1, 1}},
	{'t', {0, 1, 0, 1, 1, 0, 1}},	{'u', {0, 0, 0, 0, 1, 1, 1}},
	{'v', {0, 1, 1, 1, 1, 0, 0}},	{'w', {0, 1, 1, 0, 1, 1, 1}},
	{'x', {0, 1, 1, 1, 1, 1, 0}},	{'y', {0, 1, 1, 1, 0, 1, 1}},
	{'z', {1, 0, 1, 1, 1, 0, 1}},	{'@', {1, 0, 1, 0, 1, 1, 1}},
	{'?', {1, 0, 1, 1, 1, 0, 0}},	{'/', {0, 0, 1, 1, 1, 0, 0}},
	{ 92, {0, 1, 0, 1, 0, 1, 0}}, {'-', {0, 0, 0, 1, 0, 0, 0}},
		// backslash
	{'_', {0, 0, 0, 0, 0, 0, 1}}
};

static const struct{
	BYTE ascii;
	BYTE pattern[16];
} led1[]={
	{32, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
		// punctuation, brackets, etc.
	{33, {0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0}},
	{34, {0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
	{35, {1, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 0}},
	{36, {1, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 1}},
	{37, {1, 0, 1, 0, 1, 1, 0, 1, 1, 0, 1, 1, 0, 1, 0, 1}},
	{38, {1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1}},
	{39, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
	{40, {0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1}},
	{41, {0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1}},
	{42, {0, 0, 0, 1, 1, 1, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0}},
	{43, {0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0}},
	{45, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0}},
	{47, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0}},
		// numbers
	{48, {1, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0 ,0, 1, 1, 1}},
	{49, {0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0}},
	{50, {1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 1}},
	{51, {1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 1, 1}},
	{52, {0, 0, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0}},
	{53, {1, 1, 1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1}},
	{54, {1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1}},
	{55, {1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0}},
	{56, {1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1}},
	{57, {1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1}},
		// more brackets, etc.
	{60, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}},
	{61, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1}},
	{62, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0}},
	{63, {1, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0}},
		// '@' and capital letters
	{64, {1, 1, 0, 0, 0, 0, 1, 1, 0, 1, 0, 1, 0, 1, 1, 1}},
	{65, {1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0}},
	{66, {1, 0, 1, 0, 1, 0, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1}},
	{67, {1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1}},
	{68, {1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1}},
	{69, {1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 1}},
	{70, {1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0}},
	{71, {1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 1, 1}},
	{72, {0, 0, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0}},
	{73, {1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1}},
	{74, {1, 1, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1}},
	{75, {0, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0}},
	{76, {0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1}},
	{77, {0, 0, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0}},
	{78, {0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0}},
	{79, {1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1}},
	{80, {1, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0}},
	{81, {1, 1, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1}},
	{82, {1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0}},
	{83, {1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 1}},
	{84, {1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0}},
	{85, {0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 1}},
	{86, {0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0}},
	{87, {0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 0, 1, 1, 0, 0}},
	{88, {0, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 0, 0}},
	{89, {0, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0}},
	{90, {1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 1}},
		// even more brackets...
	{91, {1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 1}},
	{92, {0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0}},
	{93, {1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1}},
	{94, {0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
	{95, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1}},
	{96, {0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
		// minor letters
	{97, {0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1}},
	{98, {0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1}},
	{99, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1}},
	{100, {0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1}},
	{101, {0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 1}},
	{102, {0, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0}},
	{103, {0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1}},
	{104, {0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0}},
	{105, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1}},
	{106, {0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1}},
	{107, {0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0}},
	{108, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1}},
	{109, {0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 0, 0}},
	{110, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 0}},
	{111, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 1, 0, 1}},
	{112, {0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0}},
	{113, {0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0}},
	{114, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0}},
	{115, {0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1}},
	{116, {0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 1}},
	{117, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1}},
	{118, {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1 ,0, 0, 0, 0, 0}},
	{119, {0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0}},
	{120, {0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0}},
	{121, {0, 0, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0}},
	{122, {0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0}},
		// more brackets and stuff
	{123, {0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1}},
	{124, {0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0}},
	{125, {1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0}},
	{126, {0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
		// special characters, used for level display
	{128, {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}},
	{129, {0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0}},
	{130, {1, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0}},
	{131, {1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0}},
	{132, {1, 1, 1, 0, 1, 0, 0, 1, 1, 1, 0, 1, 0, 0, 1, 1}},
	{133, {1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1}}
};


/* === constructor/destructor ====================================== */
/* --- constructor ------------------------------------------------- */
LED::LED(){
	uINT i;

		// set defaults for display:
	style= SEVEN;
	size_x= 8;
	size_y= 12;
	slant= 0;
	fg_color= 15;
	bg_color= 0;
	spacing= 150;
	page= BASE;					// Page0_Offs, usually

	// guarantee proper initialization of lut:
	for(i=0; i<256; i++)
		lut[0][i]= (lut[1][i]= 0);

	// find valid lut matches:
	for(i=0; i<no_led0; i++){
		lut[0][led0[i].ascii]= i;
	}
	for(i=0; i<no_led1; i++){
		lut[1][led1[i].ascii]= i;
	}

	update_spacing();

		// home cursor for a start:
	home();
}

LED::LED(LED_style new_style, BYTE new_size_x, BYTE new_size_y,
	int new_slant, BYTE foreground, BYTE background, int new_spacing,
	BYTE new_page){

	uINT i;

		// set defaults for display:
	style= new_style;
	size_x= new_size_x;
	size_y= new_size_y;
	slant= new_slant;
	fg_color= foreground;
	bg_color= background;
	spacing= new_spacing;
	page= new_page;					// Page0_Offs, usually

	// guarantee proper initialization of lut:
	for(i=0; i<256; i++)
		lut[0][i]= (lut[1][i]= 0);

	// find valid lut matches:
	for(i=0; i<no_led0; i++){
		lut[0][led0[i].ascii]= i;
	}
	for(i=0; i<no_led1; i++){
		lut[1][led1[i].ascii]= i;
	}

	update_spacing();

		// home cursor for a start:
	home();
}

/* --- destructor -------------------------------------------------- */
LED::~LED(){

}

/* === public methods ============================================== */
/* --- set_page(new_page) ------------------------------------------ */
/*	the memory page used from now on will be new_page.
	no check for validity. */
void LED::set_page(BYTE new_page){
	page= new_page;
}

/* --- set_color(foreground, background) --------------------------- */
/*	the new foreground color will be foreground from now on. all lit
	elements will be displayed using this color. background determines
	the color for 'off'-diodes. */
void LED::set_color(BYTE foreground, BYTE background){
	fg_color= foreground;
	bg_color= background;
}

/* --- set_size(x_size, y_size) ------------------------------------ */
/*	the size of a character when displayed on screen in pixels.
	note that usually the cursor advances 150% of character width or
	height with each step horizontally or vertically. values for x_size
	and y_size should be 4 and 7 at least for SEVEN-digit-mode,
	accordingly greater for SIXTEEN.
	note also that the high-res graphics modes require larger y_size
	values to keep nice proportions. */
void LED::set_size(BYTE x_size, BYTE y_size){
	size_x= x_size;
	size_y= y_size;
	update_spacing();
}

/* --- set_slant(new_slant) ---------------------------------------- */
/*	the led's displayed can be tilted sideways to yield a kind of
	perspective view. the slant indicates the offset of the upper edges
	of the digit with respect to the lower one, in pixels.
	positive slant values render a tilt to the right.
	for proper appearance, keep new_slant a fraction of digit size! */
void LED::set_slant(int new_slant){
	slant= new_slant;
}

/* --- set_style(new_style) ---------------------------------------- */
/*	two style can be used:  SEVEN, which emulates a 7-element led (left),
	and SIXTEEN, which employs a 16-element led (right):
		-        - -
	  | |      |\|/|
	   -        - -
	  | |      |/|\|
	   -        - -

	though the former is capable of displaying characters, too, it lacks
	capitals, and is poorly legible, except for numbers.

	valid style-modes are checked. */
void LED::set_style(LED_style new_style){

	if(new_style==SEVEN || new_style==SIXTEEN)
		style= new_style;
	else{
		x_set_text_mode();
		fprintf(stderr, "Can't change LED style to %i !\n", style);
	}
}

/* --- set_spacing(new_spacing) ------------------------------------ */
/* sets the new spacing, ie the cursor movement from one display
	character to the next. the resulting advance is (new_spacing)% the
	character width size_x.
	Ie, if width is 12 pixel, and new_spacing= 150, the left margin of
	the (n+1)st character will be 18 pixels to the right of the left
	margin of the n'th character.

	if new_spacing==0, a standard spacing is assumed, which leaves three
	blank pixels between two consecutive characters.

	negative values of new_spacing may be employed, leading to an
	effective backward movement of the cursor. this may be fun to look
	at, but is potentially dangerous! */
void LED::set_spacing(int new_spacing){
	if(new_spacing)
		spacing= new_spacing;
	else
		spacing= 100*(size_x+3)/size_x;
	update_spacing();
}

/* --- led(x, y, string) ------------------------------------------- */
/*	displays a string led's with the current attributes as given,
	starting at (x, y) (lower left corner).

	this is no 'variable-argument'-function; string is simply an array of
	char's! if you want to do nifty display-gadgets, use sprintf before.

	the digits that are 'on' and 'off' are controlled by the patterns
	supplied in led0 and led1, resp.  'on' digits are painted with
	foreground color, 'off' digits with background. the room between the
	diode elements is left as is.
	from character to character, the virtual cursor advances 150% of
	size_x. an exception to this rule are '.' and ',', which are both
	displayed as a single dot and do not advance the cursor at all!

	characters for which no pattern is given in the look-up-table
	(lut) are displayed as blanks (ascii= 32).

	the newline-character '\n' triggers a call to the cr-method.

	return value is the number of characters displayed.

	no off-screen painting is allowed, but will lead to errors. */
uINT LED::led(uINT x, uINT y, char *string){
	uINT i;
	uINT dot_x;
	BYTE chr, index;

	cursor_x= x;
	cursor_y= y;

	for(i=0; (chr=string[i])!= 0; i++){
		index= lut[style][chr];

		if(chr=='\n'){
			// newline-character: -> performe lf/cr:
			cr();
		}
		else if((chr=='.') || (chr==',')){
			dot_x= cursor_x-pixel_spacing+size_x+1;
			x_line(dot_x, cursor_y, dot_x, cursor_y, page,
				fg_color);
				// do not advance the cursor!
		}
		else{
			//paint:
			digit(cursor_x, cursor_y, index);
			cursor_x+= pixel_spacing;
				// advance (spacing/100)% of character width
		}
	}

	return i;
}

/* --- led(string) ------------------------------------------------ */
/*	this method is essentially the same as led(x, y, string), but doesn't
	force a new cursor placement. instead, writing is picked up at the
	last position of the cursor.

	return value and error control as above. */
uINT LED::led(char *string){
	return (led(cursor_x, cursor_y, string));
}

/* --- bs(n) ------------------------------------------------------- */
/*	moves the cursor backwards (ie to the left) for n positions from the
	current position, using the current cursor size.

	if you wish to write repeatedly updating information on the screen
	(like the current time, mouse co-ordinates, etc.), you can simply use
	bs(led(string));
	since the return value of led is the number of characters the cursor
	has advanced.

	note: confusion might arise here as elsewhere with cursor control,
	if varying numbers of period '.' and colon ',' characters are
	introduced, since these yield only a 50% cursor advance.

	no checks for off-screen movement are done. */
void LED::bs(uINT n){
	cursor_x-= n*pixel_spacing;
}

/* --- lf() -------------------------------------------------------- */
/*	initiates a line feed, ie moves the cursor downwards one line without
	altering the horizontal position.

	no check for movement off screen performed. */
void LED::lf(){
	if(spacing)
		cursor_y+= size_y*spacing/100;
	else
		cursor_y+= size_y+3;
}

/* --- cr() -------------------------------------------------------- */
/*	does a carriage return to the led-cursor, ie advances to the next
	line and moves the cursor to the left.

	if a negative slant is present, the cursor is move that far to the
	right, that the upper left corner of the first character to be
	displayed will just touch the left border of the screen.

	no check for movement off screen performed. */
void LED::cr(){
	cursor_x= (slant<0) ? -slant : 0;
	lf();
}

/* --- home() ------------------------------------------------------ */
/*	homes the led-cursor to the upper left corner of the screen.

	the next character displayed will just touch the upper left corner of
	the screen when printed. */
void LED::home(){
	cursor_x= (slant<0) ? -slant : 0;
	cursor_y= size_y+1;
}

/* --- column() ---------------------------------------------------- */
/* returns the current cursor column in pixels. */
uINT LED::column(){
	return cursor_x;
}

/* --- row() ------------------------------------------------------- */
/* returns the current cursor row in pixels.

	no error control. not much that can go wrong, actually. */
uINT LED::row(){
	return cursor_y;
}

/* --- printable(ascii) -------------------------------------------- */
/* returns the value of ascii in the look-up table of the current digit
	display mode.  '0' indicates the this character is not printable and
	will result in a blank (' ') when displayed. */
BYTE LED::printable(char ascii){
	return (style==SEVEN) ? lut[0][ascii] : lut[1][ascii];
}

/* === private methods ============================================= */
/* --- digit(xx, yy, index)----------------------------------------- */
/*	displays a single digit with the current attributes, with (xx, yy)
	forming the lower left corner of the digit.
	index is the number of the pattern to employ from the led0/1-struct,
	and is received from the ascii-value by a look in the look-up table.
	*/
void LED::digit(uINT xx, uINT yy, BYTE index){
	uINT i, x0, y0, x1, y1;
	static uINT x[9], y[3];

	x[0]= xx;
	x[1]= xx+slant/2;
	x[2]= xx+slant;
	x[3]= x[0]+size_x;
	x[4]= x[1]+size_x;
	x[5]= x[2]+size_x;
	if(style==SIXTEEN){
		for(i=0; i<3; i++){
			x[6+i]= x[3+i];
			x[3+i]= (x[6+i]+x[i])/2;
		}
	}

	y[0]= yy;
	y[1]= yy-size_y/2;
	y[2]= yy-size_y;

	if(style==SEVEN){
		for(i=0; i<7; i++){
			switch(i){
				case (0):
					x0= x[2]+1; x1= x[5]-1; y0= (y1= y[2]);
					break;
				case (1):
					x0= x[2]; x1= x[1]; y0= y[2]+2; y1=y[1]-2;
					break;
				case (2):
					x0= x[5]; x1= x[4]; y0= y[2]+2; y1= y[1]-2;
					break;
				case (3):
					x0= x[1]+1; x1= x[4]-1; y0= (y1= y[1]);
					break;
				case (4):
					x0= x[1]; x1= x[0]; y0= y[1]+2; y1= y[0]-2;
					break;
				case (5):
					x0= x[4]; x1= x[3]; y0= y[1]+2; y1= y[0]-2;
					break;
				case (6):
					x0= x[0]+1; x1= x[3]-1; y0= (y1= y[0]);
					break;
			}
			segment(x0, y0, x1, y1, index, i);
		}
	}

	else if(style==SIXTEEN){
		for(i=0; i<16; i++){
			switch(i){
				case(0):
					x0= x[2]+1; x1= x[5]-1; y0= (y1= y[2]);
					break;
				case(1):
					x0= x[5]+1; x1= x[8]-1; y0= (y1= y[2]);
					break;
				case(2):
					x0= x[1]; x1= x[2]; y0= y[1]-1; y1= y[2]+1;
					break;
				case(3):
					x0= x[4]-1; x1= x[2]+1; y0= y[1]-1; y1= y[2]+1;
					break;
				case(4):
					x0= x[4]; x1= x[5]; y0= y[1]-1; y1= y[2]+1;
					break;
				case(5):
					x0= x[4]+1; x1= x[8]-1; y0= y[1]-1; y1= y[2]+1;
					break;
				case(6):
					x0= x[7]; x1= x[8]; y0= y[1]-1; y1= y[2]+1;
					break;
				case(7):
					x0= x[1]+1; x1= x[4]-1; y0= (y1= y[1]);
					break;
				case(8):
					x0= x[4]+1; x1= x[7]-1; y0= (y1= y[1]);
					break;
				case(9):
					x0= x[0]; x1= x[1]; y0= y[0]-1; y1= y[1]+1;
					break;
				case(10):
					x0= x[0]+1; x1= x[4]-1; y0= y[0]-1; y1= y[1]+1;
					break;
				case(11):
					x0= x[3]; x1= x[4]; y0= y[0]-1; y1= y[1]+1;
					break;
				case(12):
					x0= x[6]-1; x1= x[4]+1; y0= y[0]-1; y1= y[1]+1;
					break;
				case(13):
					x0= x[6]; x1= x[7]; y0= y[0]-1; y1= y[1]+1;
					break;
				case(14):
					x0= x[0]+1; x1= x[3]-1; y0= (y1= y[0]);
					break;
				case(15):
					x0= x[3]+1; x1= x[6]-1; y0= (y1= y[0]);
					break;
			}
			segment(x0, y0, x1, y1, index, i);
		}
	}
	else{
		x_set_text_mode();
		fprintf(stderr, "Illegal LED style: %i \n", style);
	}
}

/* --- segment(x0, y0, x1, y1, index, i) --------------------------- */
/* paints one of the diodes making up a segment.
	it's not a good idea to call this from outside the standard chain
	led -> digit -> segment. */
void LED::segment(uINT x0, uINT y0, uINT x1, uINT y1, BYTE index,
	uINT i){

	static uINT out_color;

	if(x0>MAX_X || x1>MAX_X || y0>MAX_Y || y1>MAX_Y){
		x_set_text_mode();
		fprintf(stderr, "Can't plot line from [%i/%i] to [%i/%i]. \n",
			x0, y0, x1, y1);
		fprintf(stderr, "Char.: %i    Segment: %i \n",
			index, i);
	}
	else{
		if(style==SEVEN)
			out_color= led0[index].pattern[i] ? fg_color : bg_color;
		else
			out_color= led1[index].pattern[i] ? fg_color : bg_color;

		x_line(x0, y0, x1, y1, page, out_color);
	}
}

/* --- update_spacing() -------------------------------------------- */
/* sets pixel_spacing in correct correlation to spacing. automagically
	called. */
void LED::update_spacing(){
	pixel_spacing= size_x*spacing/100;
}
/* ================================================================= */

