  /* /////////////////////////////////////////////////////////////// */
 /* ///   led_demo.cc                                           /// */
/* /////////////////////////////////////////////////////////////// */
	/* --- Elmar Vogt - V1.0 - 2.96 - DJGPP C++ 2.003 ------- */

/* a tiny demonstration package showing the features of the LED-class */

#include <stdio.h>
#include <stdlib.h>
#include <pc.h>
#include <time.h>
#include <math.h>

#include "led.h"

void wait();
void clear();
int rnd(int);

BYTE *palette;
char text[16];
char chain[6][2];
time_t sec;

float phi;
int value;

void main(){
	LED *v= new LED;
		// creates an instance of class LED, 'v' like 'video'
		// preferrably short names, we have to write it often!

	read_binary("standard.pal", &palette);
	x_set_palette(palette);
		// to make the world more colorful :-)

	x_set_mode(X_320X480);

	/* --------------------------------------------------- */
	clear();
	v->set_style(SIXTEEN);
	v->led("HELLO!.\n");
	v->cr();
	wait();

	v->set_spacing(0);
	v->set_color(WHITE, BLUE);
	v->set_size(10, 16);
	v->led("WELCOME TO OUR DEMO FOR\n");
	v->led("THE");
	v->set_color(YELLOW, BLACK);
	v->led(" LED ");
	v->set_slant(0);
	v->set_color(WHITE, BLUE);
	v->led("CLASS!.\n\n");
	v->set_size(8, 12);
	v->led("IT WAS CONCEIVED AND PROGRAMMED\n");
	v->led("BY ELMAR VOGT {c} 1996.");
	wait();

	/* --------------------------------------------------- */
	clear();
	v->set_size(8, 16);
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("THE	LED-CLASS PROVIDES YOU WITH\n");
	v->led("A SOPHISTICATED LED-DISPLAY-\n");
	v->led("EMULATION.\n");
	v->led("CHOOSE BETWEEN-\n");
	wait();

	v->led("> A SEVEN-SEGMENT MODE-\n");
	v->set_style(SEVEN);
	v->set_color(YELLOW, BLUE);
	v->lf();
	v->led("     0123456789.\n");
	v->cr();
	wait();
	v->set_style(SIXTEEN);
	v->set_color(WHITE, BLACK);
	v->led("WHICH EVEN ALLOWS PRINTING\nCHARACTERS\n");
	v->set_style(SEVEN);
	v->set_color(YELLOW, BLUE);
	v->cr();
	v->led("     hello world\n");
	v->cr();
	wait();
	v->set_style(SIXTEEN);
	v->set_color(WHITE, BLACK);
	v->led("> AND A 16-SEGMENT MODE WITH\n");
	v->led("  COMPLETE CHARACTER SET\n");
	v->set_color(YELLOW, BLUE);
	v->cr();
	v->led("ABCDEFGHIJKLM NOPQRSTUVWXYZ\n");
	v->led("abcdefghijklm nopqrstuvwxyz\n");
	v->led("0123456789 %$&/_*+-={}[]<>?\n");
	wait();

	/* --------------------------------------------------- */
	clear();
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("MANIPULATE GRAPHIC ATTRIBUTES\nAT WILL-\n");
	v->cr();
	v->set_color(YELLOW, BLUE);
	v->set_spacing(150);
	for(int i=0; i<3; i++){
		v->cr();
		for(int j=0; j<3; j++){
			v->set_size(8+j*5, 12+i*8);
			v->led("SIZE ");
		}
		v->cr();
	}
	wait();

	/* --------------------------------------------------- */
	clear();
	v->set_size(8, 16);
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("VARIABLE TEXT SPACING-\n");
	v->cr();
	v->set_color(YELLOW, BLUE);
	for(int i=130; i<210; i+=20){
		v->set_spacing(i);
		v->led("SPACE ");
	}
	v->cr();
	wait();

	/* --------------------------------------------------- */
	clear();
	v->home();
	v->set_spacing(0);
	v->set_color(WHITE, BLACK);
	v->led("GIVE YOUR TEXT A SLANT-\n");
	v->set_color(YELLOW, BLUE);
	for(int i=-6; i<6; i+=2){
		v->set_slant(i);
		v->cr();
		v->led("BACKWARD SLANT FORWARD\n");
	}
	wait();

	/* --------------------------------------------------- */
	clear();
	v->set_slant(0);
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("CHANGE FOREGROUND & BACKGROUND\n");
	v->led("COLORS AT RANDOM-\n");
	v->set_color(YELLOW, BLUE);
	v->set_size(20, 36);

	int k=0;
	while(!kbhit()){
		x_wait_vertical_retrace_start();
		x_wait_vertical_retrace_start();
		x_wait_vertical_retrace_start();
		v->set_color(k++, BLUE);
		v->led(10, 180, "FOREGROUND");
	}
	getkey();
	while(!kbhit()){
		x_wait_vertical_retrace_start();
		x_wait_vertical_retrace_start();
		x_wait_vertical_retrace_start();
		v->set_color(YELLOW, k++);
		v->led(10, 250, "BACKGROUND");
	}
	getkey();

	/* --------------------------------------------------- */
	clear();
	v->set_size(8, 16);
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("MIX VARIOUS DESIGNS AT ONE TIME-\n");

	for(int i=0; i<50; i++){
		v->set_size(4+rnd(15), 4+rnd(30));
		v->set_color(rnd(256), rnd(256));
		v->set_slant(-5+rnd(10));
		v->set_spacing(110+rnd(60));
		v->led(10+rnd(200),60+rnd(380),"TEXT");
	}
	wait();

	/* --------------------------------------------------- */
	clear();
	v->set_size(8, 16);
	v->set_slant(0);
	v->set_spacing(0);
	v->set_color(WHITE, BLACK);
	v->home();
	v->led(0, 40, "THEN, USE CURSOR CONTROL");
	v->set_color(YELLOW, BLUE);
	v->led(120, 150, "TO MOVE AROUND");
	v->led(120, 180, "THE SCREEN!.\n");
	wait();
	v->led("USE LINE FEEDS");
	v->lf();
	v->led("WITH LEDS, OR");
	wait();
	v->cr();
	v->led("CARRIAGE RETURNS, OR");
	wait();
	v->home();
	v->led("HOME IN ONE COMMAND!.");
	wait();
	v->led(0, 400, "BACKSPACE BLAHBLAH");
	wait();
	v->bs(8);
	v->led("ALLOWS OVERWRITE!.");
	wait();

	/* --------------------------------------------------- */
	clear();
	v->home();
	v->set_color(WHITE, BLACK);
	v->led("UPDATE SCREENS WITH TWO\nLINES OF CODE\n");
	v->led("(NO MESSED UP DISPLAYS)-");

	while(!kbhit()){

		v->set_color(YELLOW, BLUE);
		v->set_style(SIXTEEN);
		v->set_slant(0);
		v->set_size(8, 16);
		sprintf(text, "%i", clock());
		v->led(100, 200, text);

		v->set_color(LT_GREEN, BLUE);
		v->set_slant(2);
		v->set_size(8, 24);
		time(&sec);
		v->led(30, 150, ctime(&sec));
		
		v->set_color(WHITE, BROWN);
		v->set_slant(-2);
		v->set_size(6, 12);
		sprintf(text, "%i", rnd(32000));
		v->led(50, 300, text);

		v->set_style(SEVEN);
		v->set_color(LT_RED, BLACK);
		v->set_slant(2);
		v->set_size(12, 16);
		k+= rnd(200);
		sprintf(text, "%i", k);
		v->led(120, 250, text);
	}
	getkey();

	/* --------------------------------------------------- */
	clear();
	v->set_color(WHITE, BLACK);
	v->set_style(SIXTEEN);
	v->set_slant(0);
	v->set_size(8, 16);
	v->home();
	v->led("CHARACTERS 128-133 CAN BE USED\n");
	v->led("FOR LED-METER CHAINS-\n");

	v->set_color(YELLOW, BLUE);
	v->set_size(8, 20);
	v->set_slant(4);
	for(int i=0; i<6; i++){
		chain[i][0]= 128+i;
		chain[i][1]= 0;
	}
	while(!kbhit()){
		phi+= 0.001;
		value= (int) 6.*(12.+11.*sin(3.2*phi+1.21)*sin(0.211*phi));
		v->led(10, 200, chain[5]);
		for(int i=0; i<value/6; i++)
			v->led(chain[5]);
		v->led(chain[value%6]);
		for(int i=value/6+1; i<25; i++)
			v->led(chain[0]);
	}
	getkey();

	x_set_text_mode();

	printf("That was all. Thank you for your interest.\n\n\n");
	printf("Please, kindly pay attention to the copyright notices:\n\n");
	printf("DJGPP is (c) by DJ Delorie: \t\t http://www.delorie.com/\n");
	printf("XLib for DJGPP is (c) by Paul Fenwick: ");
	printf("\t bg914@freenet.carleton.ca\n");
	printf("The LED-class is (c) by Elmar Vogt: ");
	printf("\t elmar.vogt@rzmail.uni-erlangen.de\n");
	printf("\n\n");
}

void wait(){
		// alternative definition:
	LED *halt= new LED(SIXTEEN, 6, 10, 0, 15, 0, 140, Page0_Offs);
		// create a second instance whose settings are independent
		// from the first. arguments are given with the definition!

	halt->led(120, 460, "HIT ANY KEY TO CONTINUE-");

		// wait for a keypress:
	getkey();
}

void clear(){
	x_rect_fill(0, 0, MAX_X, MAX_Y, Page0_Offs, 0);
}

int rnd(int value){
	return rand()%value;
}
